/*
 *
 *                         DES SOFTWARE PACKAGE
 *                             Version 2.2
 *
 *                                        _
 * Copyright (c) 1990,1991,1992,1993 Stig Ostholm.
 * All Rights Reserved
 *
 *
 * The author takes no responsibility of actions caused by the use of this
 * software package and does not guarantee the correctness of the functions.
 *
 * This software package may be freely distributed for non-commercial purpose
 * as long as the copyright notice is kept. Any changes made should be
 * accompanied by a comment indicating who made the change, when it was made
 * and what was changed.
 *
 * This software package, or any parts of it, may not be used or in any way
 * re-distributed for commercial purpose without the authors permission.
 * The author keeps the right to decide between of what is commercial and
 * what is non-commercial purpose.
 *
 * Restrictions due to national laws governing the use, import or export of
 * cryptographic software is the responsibility of the software user/importer/
 * exporter to follow.
 *
 *
 *                                              _
 *                                         Stig Ostholm
 *                                         Chalmers University of Technology
 *                                         Department of Computer Engineering
 *                                         S-412 96 Gothenburg
 *                                         Sweden
 *                                         ----------------------------------
 *                                         Email: ostholm@ce.chalmers.se
 *                                         Phone: +46 31 772 1703
 *                                         Fax:   +46 31 772 3663
 */

/*
 *			     -1
 * The initial permutation IP   as described in FIPS 46 1977 January 15.
 *
 * The permuted input has bit 40 of the input block as its first bit,
 * bit 8 as it second bit, and so on with bit 25 as its last bit.
 */

#define IPinv_ROWS	8
#define IPinv_COLUMNS	8

#ifdef __SDTC__
const
#endif
	unsigned char	ip_inv[IPinv_ROWS][IPinv_COLUMNS] = {
				{ 40,  8, 48, 16, 56, 24, 64, 32 },
				{ 39,  7, 47, 15, 55, 23, 63, 31 },
				{ 38,  6, 46, 14, 54, 22, 62, 30 },
				{ 37,  5, 45, 13, 53, 21, 61, 29 },
				{ 36,  4, 44, 12, 52, 20, 60, 28 },
				{ 35,  3, 43, 11, 51, 19, 59, 27 },
				{ 34,  2, 42, 10, 50, 18, 58, 26 },
				{ 33,  1, 41,  9, 49, 17, 57, 25 }
			};
